package cve;
import ve.*;

/**
 * An iterator over the elements of a rule collection.  This follows the basic
 * abstract Iterator interface, but doesn't throw an exception. (It
 * assumes it will be used properly.) 

 * @author David Poole
 * @version 0.1 2001-02-29 */

public interface RuleIterator {
    /**
     * Returns true if the iterator has more elements.
     *
     * @return true if the iterator has more elements.  */
    boolean hasNext();

    /**
     * Returns the next element in the iteration.
     *
     * @return the next element in the iteration.
     */
    GenRule next();

}
